/*
 *  1.5.        
 *    .        
 *  .
 */

#include <stdio.h>
#include <math.h>

typedef struct _Point {
  double x;
  double y;
} point, *pointptr;


point Pt, VtPt1, VtPt2, VtPt3;

double GetDistance(pointptr Pt0, pointptr Pt1, pointptr Pt2);


int main()
{
  double dist, min1, min2;

  fputs("Enter point x coordinate: ", stdout);
  scanf("%lf", &Pt.x);
  fputs("Enter point y coordinate: ", stdout);
  scanf("%lf", &Pt.y);

  fputs("\nEnter vertex 1 x coordinate: ", stdout);
  scanf("%lf", &VtPt1.x);
  fputs("Enter vertex 1 y coordinate: ", stdout);
  scanf("%lf", &VtPt1.y);

  fputs("Enter vertex 2 x coordinate: ", stdout);
  scanf("%lf", &VtPt2.x);
  fputs("Enter vertex 2 y coordinate: ", stdout);
  scanf("%lf", &VtPt2.y);

  fputs("Enter vertex 3 x coordinate: ", stdout);
  scanf("%lf", &VtPt3.x);
  fputs("Enter vertex 3 y coordinate: ", stdout);
  scanf("%lf", &VtPt3.y);

  dist = GetDistance(&Pt, &VtPt1, &VtPt2);
  min1 = GetDistance(&Pt, &VtPt1, &VtPt3);
  min2 = GetDistance(&Pt, &VtPt2, &VtPt3);
  if ( min1 < dist )
    dist = min1;
  if ( min2 < dist )
    dist = min2;

  printf("\nDistance from point (%.3lf,%.3lf) to the closest side of the triangle: %.3lf\n",
         Pt.x, Pt.y, dist);

  return 0;
}



/* Calculates distance between a point Pt0 and a line (designated by two
 * points Pt1 and Pt2 it passes through) */
double GetDistance(pointptr Pt0, pointptr Pt1, pointptr Pt2)
{
  double X2MinusX1, Y2MinusY1;

  X2MinusX1 = Pt2->x - Pt1->x;
  Y2MinusY1 = Pt2->y - Pt1->y;

  return
    fabs( ( Pt0->x - Pt1->x ) * Y2MinusY1 - ( Pt0->y - Pt1->y ) * X2MinusX1 ) /
    sqrt(Y2MinusY1*Y2MinusY1 + X2MinusX1*X2MinusX1);
}



/*
 * Local variables:
 * compile-command: "gcc -lm 1_05.c && ./a.out <<< \"1.6 1 1 0 1 3 3 0\""
 * End:
 */
