#include <stdio.h>
#include <stdlib.h>

int  max_size;
int  n;
int *pic;

int CheckRect(int i, int j, int k);

int main(void)
{
   int i, j, k;
   
 while ( 1 ) {
   scanf("%d", &n);
   if ( n == 0 )
     break;

    max_size = 0;
    
   pic = (int *) malloc(sizeof(int) * n * n);
   for ( i = 0; i < n * n; i++ )
     scanf("%d", pic + i );
   
   for ( i = 0; i < n; i++ )
     for ( j = 0; j < n; j++ ) {
	if ( *(pic + i * n + j ) == 0 ) {
	   /* Expand width */
	   for ( k = 1; *(pic + i * n + j - k) == 1 &&
			*(pic + i * n + j + k) == 1 &&
		        j - k >= 0 && j + k < n        ; k++ )
	     if ( CheckRect(i, j, k) ) {
		if ( k * 2 + 1 > max_size )
		  max_size = k * 2 + 1;
		j += k;
		break;
	     }
	}
     }
   
   if ( max_size == 0 ) {
     puts("No solution");
   } else 
      printf("%d\n", max_size);

    free(pic);
}
   
 return 0;
}

int CheckRect(int vert_i, int vert_j, int half_size)
{
   int i, j;
   int size = half_size * 2 + 1;
   
   if ( vert_i + size  > n ) {
     return 0;
   }
   
   /* Check first half square (plus middle line) */
   for ( i = 1; i <= half_size; i++ ) {
      /* Check white squares */
      for ( j = 0; j <= i; j++ ) {
	if ( *(pic + (vert_i + i) * n + vert_j + j) != 0 ||
	     *(pic + (vert_i + i) * n + vert_j - j) != 0 )
	  return 0;
      }
      /* Check black squares */
      for ( j = half_size; j > i; j-- ) {
	if ( *(pic + (vert_i + i) * n + vert_j + j) != 1 ||
	     *(pic + (vert_i + i) * n + vert_j - j) != 1 )
	  return 0;
      }
   }

   /* Check second half square (excl. middle line) */
   for ( i = 1; i <= half_size; i++ ) {
      /* Check white squares */
      for ( j = 0; j <= half_size - i; j++ ) {
	if ( *(pic + (vert_i + half_size + i) * n + vert_j + j) != 0 ||
	     *(pic + (vert_i + half_size + i) * n + vert_j - j) != 0 )
	  return 0;
      }
      /* Check black squares */
      for ( j = half_size; j > half_size - i; j-- ) {
	if ( *(pic + (vert_i + half_size + i) * n + vert_j + j) != 1 ||
	     *(pic + (vert_i + half_size + i) * n + vert_j - j) != 1 )
	  return 0;
      }
   }

   
   return -1;
}
