/*
 *
 */
#include <stdio.h>
#include <stdlib.h>

int  m, n;
int *a;
int  max_remainder = 0;

void combination(int i, int remainder);


int main(void)
{
  int i;

  scanf("%d%d", &m, &n);

  if ( !( a = (int *) malloc(sizeof(int) * n) ) )
    return -1;

  for ( i = 0; i < n; i++ )
    scanf("%d", a + i);

  /* We pass remainder of -1 to skip the very first combination when no elements
     of array are selected--if we pass 1, then 1 will become the maximum
     remainder after the first `zero' combination, which is a mistake */
  combination(0, -1);

  printf("%d\n", max_remainder);

  return 0;
}


void combination(int i, int remainder)
{
  long prod;

  if ( i == n ) {
    if ( remainder > max_remainder )
      max_remainder = remainder;

    return;
  }

  combination(i + 1, remainder);

  if ( remainder < 0 ) /* < 0 only for the first valid (`non-zero') combination */
    remainder = 1;

  prod = *(a + i) * remainder;
  if ( prod >= m )
    prod %= m;
  combination(i + 1, (int) prod);

  return;
}



/*
 * Local variables:
 * compile-command: "gcc -Wall las_vegas.c && ./a.out <<< \"5 3 3 3 2\""
 * End:
 */
