/*
 * Problem H.
 */
#include <stdio.h>
#include <stdlib.h>
#include <limits.h>

#define INT_WIDTH   (sizeof(int) * CHAR_BIT)

int main(void)
{
  unsigned eggs, stories, skip;
  unsigned min_exp;

  while ( 1 ) {
    scanf("%ud", &eggs);
    if ( !eggs )
      break;
    scanf("%ud", &stories);

    /* Compute how many stories we gonna skip, i.e. 2^{eggs-1} */
    if ( eggs > INT_WIDTH )
      eggs = INT_WIDTH;
    skip = 1 << (eggs - 1);

    /* Calculate number of experiments */
    if ( skip <= stories )
      min_exp = stories / skip + eggs - 1;
    else {
      min_exp = eggs - 1;
      while ( (skip >>= 1) > stories )
        min_exp--;
    }

    printf("%u\n", min_exp);
  }

  return 0;
}



/*
 * Local variables:
 * compile-command: "gcc -Wall h.c && ./a.out <<<\"1 10  2 5   0\""
 * End:
 */
