/*
 * Prints out all combinations of 0's and 1's in a binary set of length N
 */
#include <stdio.h>

#define N       5

int bset[N];

void print_bset(void);

int main(void)
{
  int i;

  for ( i = 0; i < N; i++ )
    bset[i] = 0;

  print_bset();

  /* bset is treated as binary set, we "add" 1 to it to get next combination */
  while ( 1 ) {
    for ( i = 0; i < N && bset[i] == 1; i++ )
      bset[i] = 0;
    if ( i == N )
      break;
    bset[i] = 1;
    print_bset();
  }

  return 0;
}

void print_bset(void)
{
  int i;

  for ( i = N - 1; i >= 0; i-- )
    printf("%d ", bset[i]);
  putchar('\n');
}



/*
 * Local variables:
 * compile-command: "gcc -Wparentheses -W combinations.c && ./a.out"
 * End:
 */
