/*
 * Prints out all combinations of 0's and 1's in a binary set of length N
 */
#include <stdio.h>

#define N       6

int bset[N];

void combination(int i);

int main(void)
{
  combination(0);

  return 0;
}


void combination(int i)
{
  int j;

  if ( i == N ) {                   /* no more elements in array to add */
    for ( j = 0; j < N; j++)
      printf("%d ", bset[j]);
    putchar('\n');

    return;
  }

  bset[i] = 0;
  combination(i + 1);
  bset[i] = 1;
  combination(i + 1);

  return;
}



/*
 * Local variables:
 * compile-command: "gcc -Wall recursive_combinations.c && ./a.out"
 * End:
 */
