#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MEM_CHUNK_A      128

char *a = NULL;
int   i_a = 0;
int   len_a = 0;
int   sn;
int   n;

int  itoa(char *ptr, int n, int i);
void check_size(char **ptr, int i, int *size, int chunk);
void get_a(int i);
void get_s(int i);

int main(void)
{
   int i;
   scanf("%d", &sn);

   get_s(1);
   
   return 0;
}

void get_a(int i)
{
   int j;

   if ( i == n + 1 ) {
      /* n parentheses ('\0' will take place of '-') */
      i_a += n;
      check_size(&a, i_a, &len_a, MEM_CHUNK_A);
      i_a -= n;
      i_a--; /* last `-' */
      for ( j = 0; j < n; j++ )
	*(a + i_a++) = ')';
      *(a + i_a++) = '\0';
      return;
   }
   
   /* length of `sin(200-' */
   i_a += 8;
   check_size(&a, i_a, &len_a, MEM_CHUNK_A);
   i_a -= 8;
   strncpy(a + i_a, "sin(", 4);
   i_a += 4;

   i_a += itoa(a, i_a, i);
   *(a + i_a++) = ( i % 2 ) ? '-' : '+';

   get_a(i + 1);
   
   return;
}

void get_s(int i)
{
   int j;

   if ( i == 1 ) {
      for ( j = 1; j < sn; j++ )
	putchar('(');
   }
   
   i_a = 0;
   n = i;
   get_a(1);
   fputs(a, stdout);
   putchar('+');
   printf("%d", sn - i + 1);
   if ( i < sn ) {
     putchar(')');
     get_s( i + 1);
   }
   else
     putchar('\n');

   return;
}

void check_size(char **ptr, int i, int *size, int chunk)
{
   while ( i >= *size ) {
      *size += chunk;
   }
   *ptr = (char *) realloc(*ptr, *size * sizeof(char));
}

int itoa(char *ptr, int i, int n)
{
   int start_i = i, j;
   char c;

   while ( n > 0 ) {
     *(ptr + i++) = n % 10 + '0';
      n /= 10;
   }

   for ( j = 0; j < (i - start_i) / 2; j++ ) {
     c = *(ptr + start_i + j);
      *(ptr + start_i + j) = *(ptr + i - j - 1);
      *(ptr + i - j - 1) = c;
   }

   return i - start_i;
}
