/*
 * Problem B.
 */
#include <stdio.h>
#include <stdlib.h>


#define STACK_MEM_CHUNK     245  /* does funny things when set to anything less
                                    than 245 */
#define MAX_STACKS_COUNT    1000


typedef struct _stack {
  long *ptr;
  int   len;
  int   top;
} stack, *stackptr;

stackptr stacks;


int main(void)
{
  int  n, i;
  long a, b;
  int  tmp;
  stackptr ptrStack;

  /* Get number of operations */
  scanf("%d", &n);

  /* Set up the list of stacks */
  stacks = (stackptr) malloc( sizeof(stack) * MAX_STACKS_COUNT );
  for ( i = 0; i < MAX_STACKS_COUNT; i++ ) {
    (stacks + i)->ptr = NULL;
    (stacks + i)->len = 0;
    (stacks + i)->top = 0;
  }

  /* Main loop */
  for ( i = 0; i < n; i++ ) {
    tmp = scanf(" POP %ld", &a);
    if ( tmp == 1 ) {           /* POP */
      ptrStack = stacks + a;
      printf("%ld\n", *( ptrStack->ptr + --ptrStack->top ) );
    } else {                    /* PUSH */
      scanf("USH %ld %ld", &a, &b);
      ptrStack = stacks + a;
      /* Grow stack if needed */
      while ( ptrStack->len <= ptrStack->top ) {
        ptrStack->len += STACK_MEM_CHUNK;
        ptrStack->ptr = (long *) realloc( (void *) ptrStack->ptr, ptrStack->len );
      }
      *( ptrStack->ptr + ptrStack->top++ ) = b;
    }
  }

  return 0;
}



/*
 * Local variables:
 * compile-command: "gcc -Wall b.c && ./a.out <<< \"7  PUSH 1 100  PUSH 1 200  PUSH 2 300  PUSH 2 400  POP 2  POP 1  POP 2\""
 * End:
 */
