/*
 * Problem C.
 */
#include <stdio.h>
#include <stdlib.h>


#define MAX_RABBIT_COUNT        200


void combinations(int, int);
void check_line(void);

int sel[2]; /* A pair of special rabbits we select */
int n;
int x[MAX_RABBIT_COUNT];
int y[MAX_RABBIT_COUNT];
int max = 0;


int main(void)
{
  int i;

  /* Get the stuff */
  scanf("%d", &n);
  for(i = 0; i < n; i++)
    scanf("%d%d", x + i, y + i);

  combinations(0, 0);

  printf("%d\n", max);

  return 0;
}

void combinations(int i, int nsel)
{
  if ( nsel == 2 ) {
    check_line();
    return;
  }

  if ( i == n - 1 ) {
    sel[nsel] = i;
    check_line();
    return;
  }

  combinations(i + 1, nsel);

  sel[nsel] = i;
  combinations(i + 1, nsel + 1);

  return;
}

void check_line()
{
  int i;
  int r1 = sel[0], r2 = sel[1];
  int cur = 2;

  /* See how many rabbits located on the line with the two selected rabbits */
  for( i = 0; i < n; i++ )
    if( i != r1 && i != r2 )
      if( ((long) ( x[r2] - x[r1])) * ( y[i] - y[r2]) ==
          ((long) ( y[r2] - y[r1])) * ( x[i] - x[r2])    )
        cur++;

  if( cur > max )
    max = cur;
}



/*
 * Local variables:
 * compile-command: "gcc -Wall c.c && ./a.out <<< \" 6  7 122  8 139  9 156  10 173  11 190  -100 1\""
 * End:
 */
