/*
 * Prints out all decompositions of an integer into its addends.
 */
#include <stdio.h>

void addend_decomp(int n, int l);
void space_out(int l);

int main(void)
{
  int n;

  fputs("Enter N: ", stdout);
  scanf("%d", &n);

  addend_decomp(n, 0);

  return 0;
}

void addend_decomp(int n, int l)
{
  int i;

  if ( n == 1 ) {
    fputc('1', stdout);
    fputc('\n', stdout);
    return;
  }

  fprintf(stdout, "%d\n", n);
  for ( i = 1; i < n; i++ ) {
    space_out(l);
    fprintf(stdout, "%d+", n-i);
    addend_decomp(i, l+1);
  }

  return;
}

void space_out(int l)
{
  int i;

  for ( i = l * 2; i > 0; i--)
    fputc(' ', stdout);

  return;
}



/*
 * Local variables:
 * compile-command: "gcc recursive_addend_decomp.c && echo && ./a.out <<< 5"
 * End:
 */
